> For the complete documentation index, see [llms.txt](https://docs.bloxchain.app/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.bloxchain.app/developers/sdk-examples.md).

# SDK examples

Curated snippets to get started. Full samples: [Examples basic](/protocol/examples-basic.md) (imported).

## Install

```bash
npm install @bloxchain/sdk @bloxchain/contracts viem
```

## Clients (viem)

```typescript
import { createPublicClient, createWalletClient, http } from 'viem';
import { sepolia } from 'viem/chains';
import { privateKeyToAccount } from 'viem/accounts';

const transport = http(process.env.RPC_URL!);
const chain = sepolia;
const accountAddress = process.env.ACCOUNT_ADDRESS as `0x${string}`;

export const publicClient = createPublicClient({ chain, transport });

const account = privateKeyToAccount(process.env.PRIVATE_KEY as `0x${string}`);
export const walletClient = createWalletClient({ account, chain, transport });
```

## Read contract owner (SecureOwnable)

```typescript
import { SecureOwnable } from '@bloxchain/sdk';

const ownable = new SecureOwnable(
  publicClient,
  walletClient,
  accountAddress,
  sepolia,
);

const owner = await ownable.getOwner();
console.log('Owner:', owner);
```

## Submit a transaction and wait

```typescript
const hash = await walletClient.writeContract({
  address: accountAddress,
  abi: ownable.abi,
  functionName: 'yourGovernedFunction',
  args: [/* per operation schema */],
  chain: sepolia,
  account: walletClient.account!,
});

const receipt = await publicClient.waitForTransactionReceipt({ hash });
if (receipt.status !== 'success') {
  throw new Error(`Transaction failed: ${hash}`);
}
```

Use registered operations and RBAC permissions from your deployment—see [Core patterns](/developers/sdk-core-patterns.md) and [Protocol getting started](/protocol/getting-started.md).

## Environment template

```bash
RPC_URL=https://ethereum-sepolia-rpc.publicnode.com
PRIVATE_KEY=0x...
ACCOUNT_ADDRESS=0x...
```

Pin `@bloxchain/sdk` and `@bloxchain/contracts` to the same [Protocol release](https://github.com/PracticalParticle/Bloxchain-Protocol/releases).

## Sanity scripts

Runnable integration references: `scripts/sanity-sdk/` in the [Bloxchain-Protocol](https://github.com/PracticalParticle/Bloxchain-Protocol) repository.

## Next steps

* [Quickstart](/getting-started/quickstart.md)
* [Core patterns](/developers/sdk-core-patterns.md)
* [API reference](/protocol/api-reference.md)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.bloxchain.app/developers/sdk-examples.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
